/* AUTOGENERATED FILE. DO NOT EDIT. */

/*=======Automagically Detected Files To Include=====*/
#include "unity.h"
#include "cmock.h"
#include "MockAdcModel.h"
#include "MockAdcHardware.h"

int GlobalExpectCount;
int GlobalVerifyOrder;
char* GlobalOrderError;

/*=======External Functions This Runner Calls=====*/
extern void setUp(void);
extern void tearDown(void);
extern void testInitShouldCallHardwareInit(void);
extern void testRunShouldNotDoAnythingIfItIsNotTime(void);
extern void testRunShouldNotPassAdcResultToModelIfSampleIsNotComplete(void);
extern void testRunShouldGetLatestSampleFromAdcAndPassItToModelAndStartNewConversionWhenItIsTime(void);
extern void testJustHereToTest_Should_ProperlyPassAStructAndVerifyIt(void);
extern void test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected1(void);
extern void test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected2(void);
extern void test_AdcConductor_YetAnotherTest_Should_VerifyThatPointersToStructsAreTestable(void);


/*=======Mock Management=====*/
static void CMock_Init(void)
{
  GlobalExpectCount = 0;
  GlobalVerifyOrder = 0;
  GlobalOrderError = NULL;
  MockAdcModel_Init();
  MockAdcHardware_Init();
}
static void CMock_Verify(void)
{
  MockAdcModel_Verify();
  MockAdcHardware_Verify();
}
static void CMock_Destroy(void)
{
  MockAdcModel_Destroy();
  MockAdcHardware_Destroy();
}

/*=======Test Reset Options=====*/
void resetTest(void);
void resetTest(void)
{
  tearDown();
  CMock_Verify();
  CMock_Destroy();
  CMock_Init();
  setUp();
}
void verifyTest(void);
void verifyTest(void)
{
  CMock_Verify();
}

/*=======Test Runner Used To Run Each Test=====*/
static void run_test(UnityTestFunction func, const char* name, UNITY_LINE_TYPE line_num)
{
    Unity.CurrentTestName = name;
    Unity.CurrentTestLineNumber = line_num;
#ifdef UNITY_USE_COMMAND_LINE_ARGS
    if (!UnityTestMatches())
        return;
#endif
    Unity.NumberOfTests++;
    UNITY_CLR_DETAILS();
    UNITY_EXEC_TIME_START();
    CMock_Init();
    if (TEST_PROTECT())
    {
        setUp();
        func();
    }
    if (TEST_PROTECT())
    {
        tearDown();
        CMock_Verify();
    }
    CMock_Destroy();
    UNITY_EXEC_TIME_STOP();
    UnityConcludeTest();
}

/*=======MAIN=====*/
int main(void)
{
  UnityBegin("TestAdcConductor.c");
  run_test(testInitShouldCallHardwareInit, "testInitShouldCallHardwareInit", 17);
  run_test(testRunShouldNotDoAnythingIfItIsNotTime, "testRunShouldNotDoAnythingIfItIsNotTime", 23);
  run_test(testRunShouldNotPassAdcResultToModelIfSampleIsNotComplete, "testRunShouldNotPassAdcResultToModelIfSampleIsNotComplete", 30);
  run_test(testRunShouldGetLatestSampleFromAdcAndPassItToModelAndStartNewConversionWhenItIsTime, "testRunShouldGetLatestSampleFromAdcAndPassItToModelAndStartNewConversionWhenItIsTime", 38);
  run_test(testJustHereToTest_Should_ProperlyPassAStructAndVerifyIt, "testJustHereToTest_Should_ProperlyPassAStructAndVerifyIt", 49);
  run_test(test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected1, "test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected1", 82);
  run_test(test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected2, "test_AdcConductor_AlsoHereToTest_Should_ProperlyReturnAStructAsExpected2", 93);
  run_test(test_AdcConductor_YetAnotherTest_Should_VerifyThatPointersToStructsAreTestable, "test_AdcConductor_YetAnotherTest_Should_VerifyThatPointersToStructsAreTestable", 104);

  CMock_Guts_MemFreeFinal();
  return UnityEnd();
}
